// stm8s103f3_loader.cs
using System;
using System.IO.Ports;
using System.Threading;
using System.Collections.Generic;

public partial class stm8s103f3_loader
{
	
	public static void Main(string[] arg)   { 
		
		if (arg.Length == 0) {Console.WriteLine(" Отсутствуют аргументы командной строки"); 
			Console.ReadKey(); return;}
		else fileName = arg[0];
		
		Console.WriteLine(" Обнаружены {0} аргумент(ов) командной строки", arg.Length);
		
		foreach(string strArg in arg){
			Console.WriteLine(strArg);
		}//foreach
		Console.WriteLine(" Загружен файл {0}", fileName);
						
		FileOpenMemorySorting fileSorted = new FileOpenMemorySorting(fileName);

		Console.Write("\n  All memory:");
		foreach( KeyValuePair<long, byte> kvp in fileSorted.GetAllMemoryaddressByteSorted() ){
			if(kvp.Key % 16 == 0) Console.Write("\n ${0:X4} ", kvp.Key);
			//if(kvp.Key % 32 == 0) Console.Write("\n${0:X4} ", kvp.Key);
			Console.Write("${0:X2} ", kvp.Value);
		}// foreach
		Console.WriteLine();

		Console.Write("\n  RAM memory:");
		foreach( KeyValuePair<long, byte> kvp in fileSorted.GetRAMaddressByteSorted() ){
			if(kvp.Key % 16 == 0) Console.Write("\n ${0:X4} ", kvp.Key);
			//if(kvp.Key % 32 == 0) Console.Write("\n${0:X4} ", kvp.Key);
			Console.Write("${0:X2} ", kvp.Value);
		}// foreach
		Console.WriteLine();

		Console.Write("\n  EEPROM memory:");
		foreach( KeyValuePair<long, byte> kvp in fileSorted.GetEEPROMaddressByteSorted() ){
			if(kvp.Key % 16 == 0) Console.Write("\n ${0:X4} ", kvp.Key);
			//if(kvp.Key % 32 == 0) Console.Write("\n${0:X4} ", kvp.Key);
			Console.Write("${0:X2} ", kvp.Value);
		}// foreach
		Console.WriteLine();
		
		Console.Write("\n  FLASH memory:");
		foreach( KeyValuePair<long, byte> kvp in fileSorted.GetFLASHaddressByteSorted() ){
			if(kvp.Key % 16 == 0) Console.Write("\n ${0:X4} ", kvp.Key);
			//if(kvp.Key % 32 == 0) Console.Write("\n${0:X4} ", kvp.Key);
			Console.Write("${0:X2} ", kvp.Value);
		}// foreach
		Console.WriteLine("\n");
		
		List<byte> list_Bytes = new List<byte>();
		list_Bytes.Clear();
		
		// извлечем дамп для RAM памяти
		foreach( KeyValuePair<long, byte> kvp in fileSorted.GetAllMemoryaddressByteSorted() ){
			list_Bytes.Add(kvp.Value);
		}// foreach
		list_Bytes.Reverse();  // дамп должен быть передан в обратном порядке
		
		// инициализация COM порта
		if(SerialPort.GetPortNames().Length == 0)
		{	Console.WriteLine(" COM порты не найдены");
			Console.ReadKey();
			return;}
		Console.WriteLine(" Доступны COM порты:");
        foreach (string s in SerialPort.GetPortNames())
        {
            Console.WriteLine("   {0}", s);
			portName = s;
        }
        // создаем экземпляр COM-порта с настройками для общения с начальным загрузчиком
		sPort = new SerialPort(portName, 9600);
		sPort.ReadBufferSize = 20000;
		sPort.Open();		//открываем COM порт
		//queueBytes = new Queue<byte>();
		//readThread = new Thread(Read);
		//readThread.Start();		// запускаем поток чтения COM порта

		while(unready)
		{
			//while(queueBytes.Count == 0){}  rx_byte = queueBytes.Dequeue();
			while(sPort.BytesToRead == 0){}  rx_byte = (byte)sPort.ReadByte(); // ждем версию загрузчика
			if(rx_byte == 0x14)
			{
				Console.WriteLine(" Принят байт 0x{0:X2} от boot_OPTION", rx_byte);
				Console.WriteLine(" Отправляем размер 0x{0:X2} байт блока", list_Bytes.Count);		
				byte[] txBytes = {(byte)list_Bytes.Count};
				sPort.Write(txBytes, 0, 1); // отправляем размер дампа
				unready = false;
			}

		}//while(unready)

		sPort.Write(list_Bytes.ToArray(), 0, list_Bytes.Count);				// отправляем сам дамп
		Thread.Sleep(500); // подождем пока очистится буфер передачи

		// переходим на общение с отправленным дампом, меняем скорость COM-порта
		sPort.BaudRate = 128000;
		 // где-то здесь не плохо бы очистить приемный буфер COM-порта
		
		int i = 0x0000;	// адрес первого блока
		//queueBytes.Clear(); // очистим очередь приема
		for (; i <= 0x9FFF; ){
			Console.WriteLine();
			//Console.WriteLine("${0:X4} ", i);
			
			int j = 0x003F;  // размер блока 64 байта
		
			byte[] txBytes = {(byte)(i>>8), (byte)i};
			sPort.Write(txBytes, 0, txBytes.Length); // отправляем адрес текущего блока

			Thread.Sleep(20000*j/sPort.BaudRate); // 2994 для sPort.BaudRate == 64000 и j == 0x1FFF

			for (; j >= 0x0000; i++, j-- ){ // принимаем 64 байта
				//while(queueBytes.Count == 0){}  rx_byte = queueBytes.Dequeue();
				while(sPort.BytesToRead == 0){}  rx_byte = (byte)sPort.ReadByte();
				//if((j+1) % 32 == 0) Console.Write("\n${0:X4} ", i);
				if((j+1) % 16 == 0) Console.Write("\n ${0:X4} ", i);
				Console.Write("${0:X2} ", rx_byte);
				//if (j==0x0000 | j==0x0010 | j==0x0020 | j==0x0030) Console.WriteLine(); // 16 байт в строке
				//if (j==0x0000 | j==0x0020 ) Console.WriteLine(); // 32 байта в строке
			}
		}//for (; i <= 0x9FFF; )

		//readThread.Join();
		sPort.Close();
		Console.ReadKey(); return;
    } // Main();

	/*
	    public static void Read()
		{
			while (inCycle)
			{
				try
				{
					if(sPort.BytesToRead > 0){
					queueBytes.Enqueue((byte)sPort.ReadByte());
					}
				}
				catch (TimeoutException) { }
			}
		}*/
	    
	//public static Thread readThread;
	//public static Queue<byte> queueBytes;
	public static bool inCycle = true;
	public  static byte rx_byte = 0x00;
	public  static bool unready = true;
	public  static string fileName;	
	public static SerialPort sPort;
	public static string portName;
}
// stm8s103f3_loader.cs